#-------------------------------------------------------------------------
#  Return of the Very Tiny Language (PowerPC)
#  Copyright (C) 2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
#  file : vtlfb.s  frame buffer extention
#  2005/05/12
#-------------------------------------------------------------------------

        mflr    r4
        stwu    r4, -4(r1)              # push lr
        bl      GetChar                 #
        cmpwi   r10, 'b'
        beq     1f
        b       pop2_and_Error

    1:  bl      GetChar                 #
        cmpwi   r10,'o
        beq     func_fbo                # fb open
        cmpwi   r10,'c
        beq     func_fbc                # fb close
        cmpwi   r10,'d
        beq     func_fbd                # fb dot
        cmpwi   r10,'f
        beq     func_fbf                # fb fill
        cmpwi   r10,'l
        beq     func_fbl                # fb line
        cmpwi   r10,'m
        beq     func_fbm                # fb mem_copy
        cmpwi   r10,'p
        beq     func_fbp                # fb put
        cmpwi   r10,'q
        beq     func_fbq                # fb put with mask
        cmpwi   r10,'r
        beq     func_fbr                # fb fill pattern
        cmpwi   r10,'s
        beq     func_fbs                # fb set_screen
        cmpwi   r10,'t
        beq     func_fbt                # fb put2
        b       pop2_and_Error

func_fbo:
        b       func_exit               # return

func_fbf:
        b       func_exit               # return

func_fbd:
        b       func_exit               # return

func_fbc:
        b       func_exit               # return

func_fbl:
        b       func_exit               # return

func_fbm:
        bl      MemCopy
        b       func_exit               # return

func_fbp:
        b       func_exit               # return

func_fbq:
        b       func_exit               # return

func_fbr:
        b       func_exit               # return

func_fbs:
        b       func_exit               # return

func_fbt:
        b       func_exit               # return

#---------------------------------------------------------------------------
# ꥳԡ
#  c[0] = source [v7, #+ 0] žƬɥ쥹
#  c[1] = dest   [v7, #+ 4] žƬɥ쥹
#  c[2] = length [v7, #+ 8] žХȿ
#  r0,r3-r7,ctr 
MemCopy:
        GETVAR  r7, 'c                  #  c[0] - c[2]
        lwz     r3, 0(r7)               # žɥ쥹
        lwz     r4, 4(r7)               # ž襢ɥ쥹
        lwz     r5, 8(r7)               # žХȿ
        mtctr   r5
        cmpw    r4, r3                  # r0 = ž - ž
        ble     2f                      # ž >= ž
        add     r3, r3, r5
        add     r4, r4, r5
    1:                                  # 
        lbzu    r0, -1(r3)              # -1Ƥɤ߽Ф
        stbu    r0, -1(r4)
        bdnz    1b
        blr
    2:                                  # 
        subi    r3, r3, 1
        subi    r4, r4, 1
    3:  lbzu    r0, 1(r3)               # +1Ƥɤ߽Ф
        stbu    r0, 1(r4)
        bdnz    3b
        blr
