#-------------------------------------------------------------------------
# file          : newbie.s
# created       : 2005/03/17-19,28,04/06
# assembler     : GNU as [ -mregnames ]
#
# Copyright (C) 2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
#-------------------------------------------------------------------------

.ifndef __NEWBIE
__NEWBIE = 1

.ifndef __MACRO_1
  .include "macro_1.s"
.endif

.ifndef __STDIO
  .include "stdio.s"
.endif

#---------------------------------------------------------------
# Xy[X \
#---------------------------------------------------------------
print_space:
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        li      r3, ' '
        bl      OutChar
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
        blr

#---------------------------------------------------------------
# r3ɐݒ肵l70ŕ\(2iA16iA10iAt10iA)
#---------------------------------------------------------------
print_value:
        subi    r1, r1, 16
        stswi   r3, r1, 16      # push r3-r6
        mflr    r6              # save lr
        mfcr    r5              # save cr
        li      r4, 32
        bl      PrintBinary     # 00000000010000000001000000000100 [32]
        bl      print_space     # [1]
        bl      PrintHex8       # FFFFA258 [8]
        li      r4, 12
        bl      PrintRightU     # [12]
        bl      PrintRight      # [12]
        bl      print_space     # [1]
        bl      OutChar4        # [4]
        bl      NewLine
        mtcr    r5              # restore cr
        mtlr    r6              # restore lr
        lswi    r3, r1, 16      # pop r3-r6
        addi    r1, r1, 16      # restore r1
        blr

#---------------------------------------------------------------
# w肵̓e16i10iŕ\
#---------------------------------------------------------------
PrintDecimal:
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        bl      print_space
        bl      PrintLeft
        bl      NewLine
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
        blr

#---------------------------------------------------------------
# ̒l\ (8bit)
# r4 : address
#---------------------------------------------------------------
print_mem1:
        subi    r1, r1, 16
        stswi   r3, r1, 16      # push r3-r6
        mflr    r6              # save lr
        lbz     r3, 0(r4)       # r3 = [r4] (8bit)
        mr      r5, r3
        bl      NewLine
        lis     r3, 'M'*256+'E' # 'mem1'
        addi    r3, r3, 'M'*256+'1'
        bl      OutChar4
        li      r3, '['
        bl      OutChar

        mr      r3, r4
        bl      PrintHex8       # address
        li      r3, ']'
        bl      OutChar
        bl      print_space
        mr      r3, r5
        bl      PrintHex2
        bl      print_space
        bl      PrintDecimal
        mtlr    r6              # restore lr
        lswi    r3, r1, 16      # pop r3-r6
        addi    r1, r1, 16      # restore r1
        blr

#---------------------------------------------------------------
# ̒l\ (16bit)
# r4 : address
#---------------------------------------------------------------
print_mem2:
        subi    r1, r1, 16
        stswi   r3, r1, 16      # push r3-r6
        mflr    r6              # save lr
        lhz     r3, 0(r4)       # r3 = [r4] (16bit)
        mr      r5, r3
        bl      NewLine
        lis     r3, 'M'*256+'E' # 'mem2'
        addi    r3, r3, 'M'*256+'1'
        bl      OutChar4
        li      r3, '['
        bl      OutChar

        mr      r3, r4
        bl      PrintHex8       # address
        li      r3, ']'
        bl      OutChar
        bl      print_space
        mr      r3, r5
        bl      PrintHex4
        bl      print_space
        bl      PrintDecimal
        mtlr    r6              # restore lr
        lswi    r3, r1, 16      # pop r3-r6
        addi    r1, r1, 16      # restore r1
        blr

#---------------------------------------------------------------
# ̒l\ (32bit)
# r4 : address
#---------------------------------------------------------------
print_mem4:
        subi    r1, r1, 16
        stswi   r3, r1, 16      # push r3-r6
        mflr    r6              # save lr
        lwz     r3, 0(r4)       # r3 = [r4] (32bit)
        mr      r5, r3
        bl      NewLine
        lis     r3, 'M'*256+'E' # 'mem4'
        addi    r3, r3, 'M'*256+'1'
        bl      OutChar4
        li      r3, '['
        bl      OutChar

        mr      r3, r4
        bl      PrintHex8       # address
        li      r3, ']'
        bl      OutChar
        bl      print_space
        mr      r3, r5
        bl      PrintHex8
        bl      print_space
        bl      PrintDecimal
        mtlr    r6              # restore lr
        lswi    r3, r1, 16      # pop r3-r6
        addi    r1, r1, 16      # restore r1
        blr

#---------------------------------------------------------------
# AAhXZ[u
#---------------------------------------------------------------
start:
        mflr    r0
        LWI     r3, start_addr
        stw     r0, 0(r3)
        blr

#---------------------------------------------------------------
# I
# start - finish Ɉ͂܂ꂽ̃oCgƃe\
# r0 - r29 ̓e\ (r30, r31 ͔j)
#---------------------------------------------------------------
finish:
        mflr    r31
        subi    r31, r31, 4     # end
        LWI     r30, start_addr
        lwz     r30, 0(r30)
        stwu    r4, -4(r1)      # save r4
        stwu    r3, -4(r1)      # save r3
        mfctr   r3
        stwu    r3, -4(r1)      # save ctr

        sub     r3, r31, r30
        bl      PrintLeft       # no. of bytes
        LWI     r3, bytes
        bl      OutAsciiZ
        bl      NewLine
  1:
        mr      r3, r30         # start
        bl      PrintHex8       # address
        li      r3, ' '
        bl      OutChar
        li      r3, 4
        mtctr   r3

  2:    lbz     r3, 0(r30)
        bl      PrintHex2
        li      r3, ' '
        bl      OutChar
        addi    r30, r30, 1
        bdnz    2b
        bl      NewLine
        cmpw    r31, r30
        bne     1b
        bl      NewLine

        lwz     r3, 0(r1)       # restore ctr
        mtctr   r3
        lwzu    r3, 4(r1)       # restore r3
        lwzu    r4, 4(r1)       # restore r4
        addi    r1, r1, 4       # restore r1
#        PRINTREGS
        b       Exit

.section .data

start_addr:     .int   0
bytes:          .asciz "bytes"
.endif

