#-------------------------------------------------------------------------
# file          : macro_1.s
# created       : 2005/03/17-2005/04/06,2005/05/14
# assembler     : GNU as [ -mregnames ]
#
# Copyright (C) 2005 Jun Mizutani <mizutani.jun@nifty.ne.jp>
#-------------------------------------------------------------------------

.ifndef __MACRO_1
__MACRO_1 = 1

#---------------------------------------------------------------
# ܥ(32bit)쥸
#---------------------------------------------------------------
.macro  LWI     reg, symbol
        lis     \reg, \symbol@ha
        addi    \reg, \reg, \symbol@l
.endm

#---------------------------------------------------------------
# 쥸 LR ͤɽޥ
# 쥸¸
# ٥Ȥ998:999:ȤäƤ뤳Ȥ
#   ex. PRINTLR
#---------------------------------------------------------------
.macro  PRINTLR
        subi    r1, r1, 8
        stswi   r3, r1, 8       # push r3-r4
        mflr    r4              # save lr
        LWI     r3, 998f
        bl      OutAsciiZ
        mr      r3, r4
        bl      print_value
        mtlr    r4              # restore lr
        lswi    r3, r1, 8       # pop r3-r4
        addi    r1, r1, 8       # restore r1
        b       999f
        .align  2
998:    .asciz "LR : "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 CTR ͤɽޥ
# ե饰쥸Ѳ
# ٥Ȥ998:999:ȤäƤ뤳Ȥ
#   ex. PRINTCTR
#---------------------------------------------------------------
.macro  PRINTCTR
        subi    r1, r1, 8
        stswi   r3, r1, 8       # push r3-r4
        mflr    r4              # save lr
        LWI     r3, 998f
        bl      OutAsciiZ
        mfctr   r3              #
        bl      print_value
        mtlr    r4              # restore lr
        lswi    r3, r1, 8       # pop r3-r4
        addi    r1, r1, 8       # restore r1
        b       999f
        .align  2
998:    .asciz "CTR: "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 XER ͤɽޥ
# ե饰쥸Ѳ
# ٥Ȥ998:999:ȤäƤ뤳Ȥ
#   ex. PRINTXER
#---------------------------------------------------------------
.macro  PRINTXER
        subi    r1, r1, 8
        stswi   r3, r1, 8       # push r3-r4
        mflr    r4              # save lr
        LWI     r3, 997f
        bl      OutAsciiZ
        LWI     r3, 998f
        bl      OutAsciiZ
        mfxer   r3
        bl      print_value
        mtlr    r4              # restore lr
        lswi    r3, r1, 8       # pop r3-r4
        addi    r1, r1, 8       # restore r1
        b       999f
        .align  2
997:    .asciz "     soc----------------------bbbbbbb\n"
998:    .asciz "XER: "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 CR ͤɽޥ
# ե饰쥸Ѳ
# ٥Ȥ998:999:ȤäƤ뤳Ȥ
#   ex. PRINTCR
#---------------------------------------------------------------
.macro  PRINTCR
        subi    r1, r1, 12
        stswi   r3, r1, 12      # push r3-r5
        mfcr    r4              # save cr
        mflr    r5              # save lr
        LWI     r3, 997f
        bl      OutAsciiZ
        LWI     r3, 998f
        bl      OutAsciiZ
        mr      r3, r4
        bl      print_value
        mtlr    r5              # restore lr
        mtcr    r4              # restore cr
        lswi    r3, r1, 12      # pop r3-r5
        addi    r1, r1, 12      # restore r1
        b       999f
        .align  2
997:    .asciz "     lgeslgeslgeslgeslgeslgeslgeslges\n"
998:    .asciz "CR : "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 R1 ͤɽޥ (R31˲)
#---------------------------------------------------------------
.macro  PRINTR1
        mr      r31, r1
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        LWI     r3, 998f
        bl      OutAsciiZ
        mr      r3, r31
        bl      print_value
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
        b       999f
        .align  2
998:    .asciz "r1: "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 R0 - R31 ͤɽޥ (R1Բ)
# ե饰쥸Ѳ
# ٥Ȥ998:999:ȤäƤ뤳Ȥ
#   ex. PRINTREG r1
#---------------------------------------------------------------
.macro  PRINTREG   reg
        subi    r1, r1, 12
        stswi   r3, r1, 12      # push r3-r5
        mflr    r3
        stwu    r3, -4(r1)      # push lr
        mfcr    r3
        stwu    r3, -4(r1)      # push cr
        LWI     r3, 998f
        bl      OutAsciiZ
        lwz     r3,  8(r1)      # restore r3
        mr      r3, \reg
        bl      print_value
        lwz     r3, 0(r1)
        mtcr    r3              # restore cr
        lwz     r3, 4(r1)
        mtlr    r3              # restore lr
        addi    r1, r1, 8
        lswi    r3, r1, 12      # pop r3-r5
        addi    r1, r1, 12      # restore r1
        b       999f
        .align  2
998:    .asciz "\reg: "
        .align  2
999:
.endm

#---------------------------------------------------------------
# 쥸 LR, PC ͤɽޥ
#---------------------------------------------------------------
.macro  PRINTPC
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        LWI     r3, 997f
        bl      OutAsciiZ
        lwz     r3, 0(r1)
        bl      PrintHex8

        LWI     r3, 998f
        bl      OutAsciiZ
        bl      996f            # pc-->lr
996:    mflr    r3              # lr-->r3
        bl      PrintHex8
        bl      NewLine
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
        b       999f
        .align  2
997:    .asciz "\nlr: "
998:    .asciz " pc:"
        .align  2
999:
.endm

#---------------------------------------------------------------
# ٤ƤΥ쥸ͤɽޥ
#---------------------------------------------------------------
.macro  PRINTREGS
        PRINTREG r0
        PRINTR1
        PRINTREG r2
        PRINTREG r3
        PRINTREG r4
        PRINTREG r5
        PRINTREG r6
        PRINTREG r7
        PRINTREG r8
        PRINTREG r9
        PRINTREG r10
        PRINTREG r11
        PRINTREG r12
        PRINTREG r13
        PRINTREG r14
        PRINTREG r15
        PRINTREG r16
        PRINTREG r17
        PRINTREG r18
        PRINTREG r19
        PRINTREG r20
        PRINTREG r21
        PRINTREG r22
        PRINTREG r23
        PRINTREG r24
        PRINTREG r25
        PRINTREG r26
        PRINTREG r27
        PRINTREG r28
        PRINTREG r29
        PRINTREG r30
        PRINTREG r31
.endm

#---------------------------------------------------------------
# 쥸ͤƬɥ쥹Ȥʸɽޥ
# ʸƬɥ쥹ľܻ
#   ex. PRINTSTR r0
#---------------------------------------------------------------
.macro  PRINTSTR   reg
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        mr      r3, \reg
        bl      OutAsciiZ
        bl      NewLine
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
.endm

#---------------------------------------------------------------
# 쥸ɥ쥹˳Ǽ줿ͤƬɥ쥹Ȥʸ
# ɽޥ
# ʸƬɥ쥹δܻ
#   ex. PRINTSTRI r0
#---------------------------------------------------------------
.macro  PRINTSTRI  reg
        stwu    r3, -4(r1)      # push r3
        mflr    r3              # (1) push lr
        stwu    r3, -4(r1)      # (2) push lr
        lwz     r3, 0(\reg)
        bl      OutAsciiZ
        bl      NewLine
        lwz     r3, 0(r1)       # (1) pop lr
        mtlr    r3              # (2) pop lr
        lwzu    r3, 4(r1)       # pop r3
        addi    r1, r1, 4       # restore r1
.endm

#---------------------------------------------------------------
# ꤷ(16ӥå)ɽޥ
# ٤ƤΥ쥸˲ɽǽ
#   ex. CHECK 99
#---------------------------------------------------------------
.macro  CHECK   val
        subi    r1, r1, 12
        stswi   r3, r1, 12      # push r3-r5
        mflr    r5
        mfcr    r4
        li      r3, \val
        bl      PrintLeft
        bl      NewLine
        mtcr    r4
        mtlr    r5              # restore lr
        lswi    r3, r1, 12      # pop r3-r5
        addi    r1, r1, 12      # restore r1
.endm

#---------------------------------------------------------------
# Ԥ
#---------------------------------------------------------------
.macro  PAUSE
        stwu    r0, -4(r1)      # push r0
        mflr    r0              # (1) push lr
        stwu    r0, -4(r1)      # (2) push lr
        bl      InChar
        lwz     r0, 0(r1)       # (1) pop lr
        mtlr    r0              # (2) pop lr
        lwzu    r0, 4(r1)       # pop r0
        addi    r1, r1, 4       # restore r1
.endm

#---------------------------------------------------------------
# 32bitοͤ쥸
#---------------------------------------------------------------
.macro  LDCONST reg, const
        lis     \reg, \const>>16     # 16bit
        addi    \reg, \reg, \const&0xFFFF
.endm

.endif
