# /usr/include/sys/syscall.h 

sys_syscall        = 0
sys_exit           = 1
sys_fork           = 2
sys_read           = 3
sys_write          = 4
sys_open           = 5
sys_close          = 6
sys_wait4          = 7
			/* = 8  old creat */
sys_link           = 9
sys_unlink         = 10
			/* = 11  old execv */
sys_chdir          = 12
sys_fchdir         = 13
sys_mknod          = 14
sys_chmod          = 15
sys_chown          = 16
sys_obreak         = 17
.ifdef COMPAT_GETFSSTAT
sys_ogetfsstat     = 18
.else
sys_getfsstat      = 18
.endif
			/* = 19  old lseek */
sys_getpid         = 20
			/* = 21  old mount */
			/* = 22  old umount */
sys_setuid         = 23
sys_getuid         = 24
sys_geteuid        = 25
sys_ptrace         = 26
sys_recvmsg        = 27
sys_sendmsg        = 28
sys_recvfrom       = 29
sys_accept         = 30
sys_getpeername    = 31
sys_getsockname    = 32
sys_access         = 33
sys_chflags        = 34
sys_fchflags       = 35
sys_sync           = 36
sys_kill           = 37
			/* = 38  old stat */
sys_getppid        = 39
			/* = 40  old lstat */
sys_dup            = 41
sys_pipe           = 42
sys_getegid        = 43
sys_profil         = 44
sys_ktrace         = 45
sys_sigaction      = 46
sys_getgid         = 47
sys_sigprocmask    = 48
sys_getlogin       = 49
sys_setlogin       = 50
sys_acct           = 51
sys_sigpending     = 52
sys_sigaltstack    = 53
sys_ioctl          = 54
sys_reboot         = 55
sys_revoke         = 56
sys_symlink        = 57
sys_readlink       = 58
sys_execve         = 59
sys_umask          = 60
sys_chroot         = 61
			/* = 62  old fstat */
			/* = 63  used internally , reserved */
			/* = 64  old getpagesize */
sys_msync          = 65
sys_vfork          = 66
			/* = 67  old vread */
			/* = 68  old vwrite */
sys_sbrk           = 69
sys_sstk           = 70
			/* = 71  old mmap */
sys_ovadvise       = 72
sys_munmap         = 73
sys_mprotect       = 74
sys_madvise        = 75
			/* = 76  old vhangup */
			/* = 77  old vlimit */
sys_mincore        = 78
sys_getgroups      = 79
sys_setgroups      = 80
sys_getpgrp        = 81
sys_setpgid        = 82
sys_setitimer      = 83
			/* = 84  old wait */
sys_swapon         = 85
sys_getitimer      = 86
			/* = 87  old gethostname */
			/* = 88  old sethostname */
sys_getdtablesize  = 89
sys_dup2           = 90
			/* = 91  old getdopt */
sys_fcntl          = 92
sys_select         = 93
			/* = 94  old setdopt */
sys_fsync          = 95
sys_setpriority    = 96
sys_socket         = 97
sys_connect        = 98
			/* = 99  old accept */
sys_getpriority    = 100
			/* = 101  old send */
			/* = 102  old recv */
.ifdef __ppc__
			/* = 103  old sigreturn */
.else
sys_sigreturn      = 103
.endif
sys_bind           = 104
sys_setsockopt     = 105
sys_listen         = 106
			/* = 107  old vtimes */
			/* = 108  old sigvec */
			/* = 109  old sigblock */
			/* = 110  old sigsetmask */
sys_sigsuspend     = 111
			/* = 112  old sigstack */
			/* = 113  old recvmsg */
			/* = 114  old sendmsg */
			/* = 115  old vtrace */
.ifdef __ppc__
sys_ppc_gettimeofday = 116
sys_gettimeofday = 116
.else
sys_gettimeofday   = 116
.endif
sys_getrusage      = 117
sys_getsockopt     = 118
			/* = 119  old resuba */
sys_readv          = 120
sys_writev         = 121
sys_settimeofday   = 122
sys_fchown         = 123
sys_fchmod         = 124
			/* = 125  old recvfrom */
			/* = 126  old setreuid */
			/* = 127  old setregid */
sys_rename         = 128
			/* = 129  old truncate */
			/* = 130  old ftruncate */
sys_flock          = 131
sys_mkfifo         = 132
sys_sendto         = 133
sys_shutdown       = 134
sys_socketpair     = 135
sys_mkdir          = 136
sys_rmdir          = 137
sys_utimes         = 138
sys_futimes        = 139
sys_adjtime        = 140
			/* = 141  old getpeername */
			/* = 142  old gethostid */
			/* = 143  old sethostid */
			/* = 144  old getrlimit */
			/* = 145  old setrlimit */
			/* = 146  old killpg */
sys_setsid         = 147
			/* = 148  old setquota */
			/* = 149  old qquota */
			/* = 150  old getsockname */
sys_getpgid        = 151
sys_setprivexec    = 152
sys_pread          = 153
sys_pwrite         = 154
.ifdef NFSSERVER
sys_nfssvc         = 155
.else
			/* = 155  */
.endif
			/* = 156  old getdirentries */
sys_statfs         = 157
sys_fstatfs        = 158
sys_unmount        = 159
			/* = 160  old async_daemon */
.ifdef NFSCLIENT
sys_getfh          = 161
.else
			/* = 161  */
.endif
			/* = 162  old getdomainname */
			/* = 163  old setdomainname */
			/* = 164  */
sys_quotactl       = 165
			/* = 166  old exportfs */
sys_mount          = 167
			/* = 168  old ustat */
			/* = 169  */
sys_table          = 170
			/* = 171  old wait3 */
			/* = 172  old rpause */
sys_waitid         = 173
			/* = 174  old getdents */
			/* = 175  old gc_control */
sys_add_profil     = 176
			/* = 177  */
			/* = 178  */
			/* = 179  */
sys_kdebug_trace   = 180
sys_setgid         = 181
sys_setegid        = 182
sys_seteuid        = 183
.ifdef __ppc__
sys_sigreturn      = 184
.else
			/* = 184  */
.endif
			/* = 185  */
			/* = 186  */
			/* = 187  */
sys_stat           = 188
sys_fstat          = 189
sys_lstat          = 190
sys_pathconf       = 191
sys_fpathconf      = 192
.ifdef COMPAT_GETFSSTAT
sys_getfsstat      = 193
.else
			/* = 193  */
.endif
sys_getrlimit      = 194
sys_setrlimit      = 195
sys_getdirentries  = 196
sys_mmap           = 197
			/* = 198  __syscall */
sys_lseek          = 199
sys_truncate       = 200
sys_ftruncate      = 201
sys___sysctl       = 202
sys_mlock          = 203
sys_munlock        = 204
sys_undelete       = 205
.ifdef __ppc__
sys_ATsocket       = 206
sys_ATgetmsg       = 207
sys_ATputmsg       = 208
sys_ATPsndreq      = 209
sys_ATPsndrsp      = 210
sys_ATPgetreq      = 211
sys_ATPgetrsp      = 212
			/* = 213  Reserved for AppleTalk */
.else
sys_ATsocket       = 206
sys_ATgetmsg       = 207
sys_ATputmsg       = 208
sys_ATPsndreq      = 209
sys_ATPsndrsp      = 210
sys_ATPgetreq      = 211
sys_ATPgetrsp      = 212
			/* = 213  Reserved for AppleTalk */
.endif /* __ppc__ */
sys_kqueue_from_portset_np = 214
sys_kqueue_portset_np = 215
sys_mkcomplex      = 216
sys_statv          = 217
sys_lstatv         = 218
sys_fstatv         = 219
sys_getattrlist    = 220
sys_setattrlist    = 221
sys_getdirentriesattr = 222
sys_exchangedata   = 223
.ifdef __APPLE_API_OBSOLETE
sys_checkuseraccess = 224
.else
			/* = 224  HFS checkuseraccess check access to a file */
.endif /* __APPLE_API_OBSOLETE */
sys_searchfs       = 225
sys_delete         = 226
sys_copyfile       = 227
			/* = 228  */
			/* = 229  */
sys_poll           = 230
sys_watchevent     = 231
sys_waitevent      = 232
sys_modwatch       = 233
sys_getxattr       = 234
sys_fgetxattr      = 235
sys_setxattr       = 236
sys_fsetxattr      = 237
sys_removexattr    = 238
sys_fremovexattr   = 239
sys_listxattr      = 240
sys_flistxattr     = 241
sys_fsctl          = 242
sys_initgroups     = 243
			/* = 244  */
			/* = 245  */
			/* = 246  */
.ifdef NFSCLIENT
sys_nfsclnt        = 247
sys_fhopen         = 248
.else
			/* = 247  */
			/* = 248  */
.endif
			/* = 249  */
sys_minherit       = 250
sys_semsys         = 251
sys_msgsys         = 252
sys_shmsys         = 253
sys_semctl         = 254
sys_semget         = 255
sys_semop          = 256
sys_semconfig      = 257
sys_msgctl         = 258
sys_msgget         = 259
sys_msgsnd         = 260
sys_msgrcv         = 261
sys_shmat          = 262
sys_shmctl         = 263
sys_shmdt          = 264
sys_shmget         = 265
sys_shm_open       = 266
sys_shm_unlink     = 267
sys_sem_open       = 268
sys_sem_close      = 269
sys_sem_unlink     = 270
sys_sem_wait       = 271
sys_sem_trywait    = 272
sys_sem_post       = 273
sys_sem_getvalue   = 274
sys_sem_init       = 275
sys_sem_destroy    = 276
sys_open_extended  = 277
sys_umask_extended = 278
sys_stat_extended  = 279
sys_lstat_extended = 280
sys_fstat_extended = 281
sys_chmod_extended = 282
sys_fchmod_extended = 283
sys_access_extended = 284
sys_settid         = 285
sys_gettid         = 286
sys_setsgroups     = 287
sys_getsgroups     = 288
sys_setwgroups     = 289
sys_getwgroups     = 290
sys_mkfifo_extended = 291
sys_mkdir_extended = 292
sys_identitysvc    = 293
			/* = 294  */
			/* = 295  */
sys_load_shared_file = 296
sys_reset_shared_file = 297
sys_new_system_shared_regions = 298
sys_shared_region_map_file_np = 299
sys_shared_region_make_private_np = 300
			/* = 301  */
			/* = 302  */
			/* = 303  */
			/* = 304  */
			/* = 305  */
			/* = 306  */
			/* = 307  */
			/* = 308  */
			/* = 309  */
sys_getsid         = 310
sys_settid_with_pid = 311
			/* = 312  */
sys_aio_fsync      = 313
sys_aio_return     = 314
sys_aio_suspend    = 315
sys_aio_cancel     = 316
sys_aio_error      = 317
sys_aio_read       = 318
sys_aio_write      = 319
sys_lio_listio     = 320
			/* = 321  */
			/* = 322  */
			/* = 323  */
sys_mlockall       = 324
sys_munlockall     = 325
			/* = 326  */
sys_issetugid      = 327
sys___pthread_kill = 328
sys_pthread_sigmask = 329
sys_sigwait        = 330
sys___disable_threadsignal = 331
sys___pthread_markcancel = 332
sys___pthread_canceled = 333
sys___semwait_signal = 334
sys_utrace         = 335
			/* = 336  */
			/* = 337  */
			/* = 338  */
			/* = 339  */
			/* = 340  */
			/* = 341  */
			/* = 342  */
			/* = 343  */
			/* = 344  */
			/* = 345  */
			/* = 346  */
			/* = 347  */
			/* = 348  */
			/* = 349  */
sys_audit          = 350
sys_auditon        = 351
			/* = 352  */
sys_getauid        = 353
sys_setauid        = 354
sys_getaudit       = 355
sys_setaudit       = 356
sys_getaudit_addr  = 357
sys_setaudit_addr  = 358
sys_auditctl       = 359
			/* = 360  */
			/* = 361  */
sys_kqueue         = 362
sys_kevent         = 363
sys_lchown         = 364
			/* = 365  */
			/* = 366  */
			/* = 367  */
			/* = 368  */
			/* = 369  */
sys_MAXSYSCALL	= 370

